# /** DoorMerge2 (c) 1986-87 John Morris   I/O, Time check, Err routine
#     06/30/87  v.4.0       RBBS-PC 15.1A comp.

#9001 GOTO In.put      '/** Make Door merge compatible with Nochange pgm's
#9100 GOTO Out.put     '/** Remove rem marker

# use Term::ReadKey;

sub in_put  {
        my ($prompt) = @_;
	$argstr='';
        $p_line=0;
        $nofsxstr='';
        $endtime=&{$fnti}+$log_offstr*60;
	$astr = '';
        Out($prompt) if defined $prompt;
	if ($zxstr = shift @zxstr)  {
		&give_token;
		&get_token;
		$argstr = $zxstr;
		Out($argstr);
		$astr = "$EOL";
	}
	else  {
		while ($astr !~ /^[\x0a\x0d]{1,2}$/)  {
			&give_token;
        		if (&{$fnti} > $endtime)  {    # Idle user check
                		$x_lnstr="NO INPUT IN $log_offstr".
                        		        " MINUTES! YOU ARE LOGGED OFF! BYE!";
      		        	&x_lnprint($x_lnstr,$snoop,$l_ocal);
                		&fast_exit;
			}
	        	&car_test;
			$rin = $win = $ein = '';
			$astr=GetKey();
			if(!defined $astr) {
				$astr = '';
			}
			if (defined $astr)  {
				if ($astr =~ /[\x07\x08]/)  {        # Backspace
        				if (length($argstr) > 0)  {
        					$argstr = substr($argstr,0,-1);
        					Out($back_spstr);
					}
				}
				elsif (ord($astr) > 31)  {
					$argstr .= $astr;
					Out($astr);
				}
			}
                        if (&get_token == 1)  {
                                Out($prompt,$argstr);
                        }
		}
	}
	if ($argstr =~ /;/)  {
		push @zxstr,split(/;/,$argstr);
		$argstr = shift @zxstr;
	}
	Out("$EOL");
}

sub out_put  {
        # ** Print LN$: If NORET=1 then print without carriage return
        if ($graphics == 1)  {
                &ansi_color;
        }
        if ($noret == 1)  {
                $noret=0;
                # Insert Out.put1 here...
                # out_put1:                              #** PRINT LN$ W/O C/R
                # IF L.OCAL <> 1 AND NOT SNOOP THEN _
                #         GOTO Out.put2
                # PRINT LN$;
                # $lnstr=$lnstr;

                # out_put2:
                # IF L.OCAL = 1 THEN _
                #         GOTO Chk.line1
                Out($lnstr);
                &car_test;
        }
        else  {
                # Insert Out.put3 here
                # out_put3:                               #** PRINT LN$ W/ C/R
                # IF L.OCAL <> 1 AND NOT SNOOP THEN _
                #        GOTO Out.put4
                # PRINT LN$
                # $l_ocal = $l_ocal;
                # out_put4:
                # IF L.OCAL = 1 THEN _
                #         GOTO Chk.line1
                Out("$lnstr\r");
                if ($lfeed == 1)  {
                        Out($lfstr);
                }
                &car_test;
                $p_line+=1;
        }
        chk_line1:
        &lin_cntr if ($p_line == 23);

        chk_line2:
        &check_time2;
        &check_time1;
        $noret=0;
}

sub lin_cntr  {                                      #** pause if > 23 lns **
        $lnstr = "[ENTER] to continue, [E] to end ";
        $notet = 1;
        &out_put;
        &in_put;
        $nofsxstr=$argstr;
        if ($nofsxstr=~/[eE]/)  {
                $nofsxstr="Q";
        }
        $p_line=0;                                  #** reset line counter
}

sub car_test  {                                      #** Check carrier drop
#     IF L.OCAL = 1 THEN _
#        RETURN
#     IF INP(MSR) => 128 THEN _
#        RETURN
#     IF SNOOP THEN _
#        PRINT "(**CARRIER DROPPED**) Returning to RBBS!"
#     RETURN Car.drop
}

sub car_drop  {
     &exit_door;
     exit;
}

sub fast_exit  {                              #** Close and return to system
#     CLOSE
#     OUT MCR,INP(MCR) OR 1
#     SYSTEM
        exit;
}

sub exit_door  {
        exit;
}
#        exit if ($no_monitor == 1);
# exit_door1:
#         RUN MON.SUB$ + "MONITOR1.EXE"

#Err.routine:                                   '** Error routine
#     IF ERR = 57 THEN _                        'Tolerate lousy communications
#        RESUME
#     IF ERL = 2 THEN
#                PRINT "ERROR WITH MAIN MESSAGE FILE  (MESSAGES)"
#        RESUME Fast.exit
#     END IF
#     IF ERL = 64005 AND ERR = 5 THEN _
#        RESUME NEXT
#     IF ERL = 64002 AND ERR = 53 THEN
#        RESUME Indoor.end
#     END IF
#
#     IF ERL = 64003 AND ERR = 53 THEN
#        PRINT DEF.NAME$;" -- (RBBS-PC.DEF) NOT FOUND!"
#        RESUME Fast.exit
#     END IF
#
#         IF (ERR = 5 OR ERR = 6 OR ERR = 13 OR ERR = 15) THEN _
#        RESUME
#
#         IF ERR = 75 THEN
#        LN$ = "FILE ACCESS ERROR - STOPPING " + DOOR.NAME$
#        GOSUB Out.put
#        RESUME Exit.door
#     END IF

#Write.err:
#     CLOSE 4
#     LN$ = "Error >" + _
#           STR$(ERR) + _
#           " Line >" + _
#           STR$(ERL) + _
#           " In file >" + _
#           DOOR.NAME$ + _
#           " on date >" + _
#           DATE$ + _
#           " " + _
#           TIME$
#     GOSUB Out.put
#     OPEN "ERRORS.DOR" FOR APPEND AS #4
#     PRINT #4, LN$
#     CLOSE #4
#     GOTO Exit.door

sub check_time1  {
        $warning = $time_off - 180;
        if (&{$fnti} > $warning && $t_imer == 1)  {
                $warning += 60;
                $x_lnstr="** YOU HAVE " . int(($time_off-&{$fnti})/60) .
                                " MINUTES REMAINING!! **";
                &x_lnprint($x_lnstr,$snoop,$l_ocal);
                $t_imer = 0;
                return;
        }
}

sub check_time2  {
        if (&{$fnti} > $time_off)  {
                $x_lnstr = "TIME LIMIT EXCEEDED!";
                &x_lnprint($x_lnstr,$snoop,$l_ocal);
                &fast_exit;
        }
}

#Chatter:                                       '*** F-10 CHAT MODE ***
#     SAVETIME = TIME.OFF-FNTI!
#      LINE.SAVE$ = LN$
#      NORET = 0
#      LN$ = ""
#      GOSUB Out.put
#      GOSUB Out.put
#      PRINT "SysOp - Hit ESC to exit chat mode"
#      LN$ = "Hi " + _
#            FIRST$ + _
#            "!  This is " + _
#            SYSOP.FIRST$ + _
#            " " + _
#            SYSOP.LAST$ + _
#            ","
#      GOSUB Out.put
# 
# Remote:
#      IF LOC(3) = 0 THEN _
#         GOTO Local.test
#      CHAT$ = INPUT$(1,3)
#      IF ASC(CHAT$) = 8 THEN
#         PRINT BK.ARW$;
#         PRINT #3, BACK.SP$;
#      END IF
#      IF ASC(CHAT$) = 27 THEN _
#         GOTO Local.inp
#      PRINT CHAT$;
#      PRINT #3,CHAT$;
#      IF ASC(CHAT$) = 13 THEN _
#         PRINT #3,CHR$(10);
#      GOTO Remote
# 
# Local.test:
#      GOSUB Car.test
#      CHAT$ = INKEY$
#      IF LEN(CHAT$) = 0 THEN _
#         GOTO Remote
# 
# Local.inp:
#      IF ASC(CHAT$) = 27 THEN _
#         GOTO Chat.end
#      IF ASC(CHAT$) = 8 THEN
#         PRINT BK.ARW$;
#         PRINT #3, BACK.SP$;
#      END IF
#      PRINT CHAT$;
#      PRINT #3,CHAT$;
#      IF ASC(CHAT$) = 13 THEN _
#         PRINT #3,CHR$(10);
#      GOTO Remote

# Chat.end:
#      TIME.OFF = FNTI! + SAVETIME
#      WARNING = TIME.OFF-(3*60)
#      ENDTIME = FNTI! + 240
#      LN$ = ""
#      GOSUB Out.put
#      ARG$ = ""
#      LN$ = "Chat mode terminated"
#      GOSUB Out.put
#      LN$ = LINE.SAVE$
#      GOSUB Out.put
#      RETURN

# Forceoff:                                      '*** F-9 FORCE OFF ***
#      TEMP.STRING$ = STRING$(15,"*")
#      LINE.SAVE$ = LN$
#      PRINT "SysOp, how many minutes till user is forced off [";_
#            INT((TIME.OFF-FNTI!)/60);"]";
#      INPUT MIN.F.O$
#      IF MIN.F.O$ = "" THEN _
#         RETURN
#      FORCE.OFF = VAL(MIN.F.O$)
#      LN$ = TEMP.STRING$ + _
#            "> IMPORTANT MESSAGE <" + _
#            TEMP.STRING$
#      GOSUB Out.put
#      LN$ = SYSOP.FIRST$ + _
#            " " + _
#            SYSOP.LAST$ + _
#            " needs to use " + _
#            RBBS.NAME$ + _
#            "!  It will be closing down"
#      GOSUB Out.put
#      LN$ = "in" + _
#            STR$(FORCE.OFF) + _
#            " minutes!  Please complete what you are doing within that time"
#      GOSUB Out.put
#      LN$ = TEMP.STRING$ + _
#            ">   END OF MESSAGE  <" + _
#            TEMP.STRING$
#      GOSUB Out.put
#      LN$ = LINE.SAVE$
#      GOSUB Out.put
#      TIME.OFF = FNTI! + (FORCE.OFF*60)
#      WARNING = TIME.OFF - (3*60)
#      RETURN

sub indoor  {
        # Line 64002
        if (-e "$time_off_filestr")  {
                open FILE2,"$time_off_filestr";
                ($time_off,$usernum,$points,$min,$nulls,$graphics,$mon_substr,$soundstr)=split(/,/,chomp($input_line));
                close FILE2;
                $o_penfilestr2='';
                $orig_points = $points;
        }
        else  {
                ($time_off,$usernum,$points,$nulls,$graphics,$mon_substr,$soundstr)=(&{$fnti}+3600,1,0,"\x00",1,'','');
        }
}

sub indoor_end  {
        $ec=0;
        $time_off = &{$fnti} + 2700;
        $no_monitor=1;
}

sub outdoor  {
        return if ($no_monitor == 1);   # EXIT IF RUNNING WITHOUT DOOR MONITOR
        open FILE2,">$mon_substr/$points_filestr";
        binmode FILE2;
        $midsec = &{$fnti};
        $new_points = $points - $orig_points;
        print FILE2 "$midsec\n";
        print FILE2 "$new_points\n";
        close FILE2;
        $o_penfilestr2='';
}

# sub x_lnprint  {
#     IF SNOOP THEN _
#        PRINT X.LN$
#     IF L.OCAL<>1 THEN _
#        PRINT #3,X.LN$
#         print "$x_lnstr\n";
# }

sub read_def  {
# 64003 OPEN DEF.NAME$ FOR INPUT AS #1
#      INPUT #1, Q$,Q$,Q$,SYSOP.FIRST$,SYSOP.LAST$,Q,Q,Q,Q!,Q,Q,Q$,Q,Q,Q,Q,Q,Q$,Q$,Q$,Q$,Q$,Q$,Q,Q,Q,Q,Q,Q,Q$
#      INPUT #1, MESSAGE.FILE$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,COM.PORT$,Q,Q$,Q$,Q,Q,Q,Q,Q$,Q$,Q
#      INPUT #1, Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q$,Q,Q,Q,Q,Q,Q,Q,Q,Q$
#      INPUT #1, Q,Q,Q,Q$,Q,Q$,Q,Q,Q,Q,Q,Q,Q,Q,Q$,Q,Q,Q,Q,Q
#      INPUT #1, Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q$
#      INPUT #1, Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q,Q!,Q,Q,RBBS.NAME$
#      CLOSE 1                              '** Q, Q$, Q!   dummy variables **
#      IF COM.PORT$ = "COM1" THEN
#         MCR = &H3FC
#         MSR = &H3FE
#         RETURN
#      END IF
#      MCR = &H2FC
#      MSR = &H2FE
#      RETURN
        open TW2DAT,"tw2.dat";
        binmode TW2DAT;
        ($filstr,$log_offstr,$alias,$min) = <TW2DAT>;
		if($log_offstr !~ /(0-9)/) {
			$log_offstr=5;
		}
        close TW2DAT;

#        open FILE1,"$def_namestr";
#        @dropfile=<FILE1>;
#	foreach (@dropfile)  {
#		s/[\x0a\x0d]//g;
#	}
#        close FILE1;
#        $o_penfilestr1='';
#        if (defined $dropfile[34])  {
#                $sysop_name=chomp($dropfile[34]);
#        }
#        else  {
#                $sysop_name='Nasty Kludge';
#        }
#        $sysop_name=~/^(.*)\s*(.*)$/;
#        $sysop_firststr=$1;
#        $sysop_laststr=$2;
#        $message_filestr="MESSAGE.FILE";
#        $com_portstr=$dropfile[0];
#        $rbbs_namestr='Just a hack in here for now.';
#        $t_imer=1;
#        $time_off=&{$fnti}+$dropfile[17];
#        $usernum=$dropfile[25];
#        $points=0;
#        $min=$dropfile[18] if ($min == 0 || $min > $dropfile[18]);
#        $nulls=0;
#        $graphics=($dropfile[19] eq 'GR');
#        $mon_substr='';
#        $soundstr='';
#        $bpstr=$dropfile[4];
#        $grp=2 if ($dropfile[19] eq 'GR');
#        $grp=1 if ($dropfile[19] eq 'NG');
#        $grp=0 if ($dropfile[19] eq '7E');
#        $par=$dropfile[2];
#        $snoop=$dropfile[5];
#        $door_users_namestr=$dropfile[9];
#        $door_users_namestr=~/ /;
#        $first_name_end=pos($door_users_namestr);
#        $last_name_end=length($door_users_namestr);
#        if($door_users_namestr=~/^([^ ]*)\s+(.*)/)  {
#                ($firststr,$laststr)=($1,$2);
#        }
#        else  {
#                ($firststr,$laststr)=($door_users_namestr,'');
#        }
#        $user_namestr="$firststr $laststr";

	OpenDoor($def_namestr);
        $sysop_name='Sysop';
        $sysop_name=~/^(.*)\s*(.*)$/;
        $sysop_firststr="Sys";
        $sysop_laststr="Op";
        $message_filestr="MESSAGE.FILE";
        $com_portstr=$dropfile{'Comm Handle'};
        $rbbs_namestr='Just a hack in here for now.';
        $t_imer=1;
        $time_off=&{$fnti}+$dropfile{'Time Left'};
        $usernum=$dropfile{'User Record'};
        $points=0;
        $min=$dropfile{'Time Left'} if ($min == 0 || $min > $dropfile{'Time Left'});
        $nulls=0;
        $graphics=($dropfile{'Emulation'});
        $mon_substr='';
        $soundstr='';
        $bpstr=$dropfile[4];
        $grp=2 if ($dropfile{'Emulation'});
        $grp=0 if (!$dropfile{'Emulation'});
        $par=0;
        $snoop=0;
        $door_users_namestr=$dropfile{'Real Name'};
        $door_users_namestr=~/ /;
        $first_name_end=pos($door_users_namestr);
        $last_name_end=length($door_users_namestr);
        if($door_users_namestr=~/^([^ ]*)\s+(.*)/)  {
                ($firststr,$laststr)=($1,$2);
        }
        else  {
                ($firststr,$laststr)=($door_users_namestr,'');
        }
        $user_namestr="$firststr $laststr";
}

sub sysop_name  {
        $sys_op=1;
#        $local = 1 if (INP(MSR)<128
        $firststr = $sysop_firststr;
        $laststr=$system_laststr;
        close FILE3;
}

sub read_command  {
    $def_namestr = "RBBS-PC.DEF";
    $rdstr = join(' ',@ARGV);
    $rdstr='-' if (length($rdstr) == 0);
    $rdstr=~/^([0-9])*(?: (.*))?/;
    if (defined $1)  {        
        $node = $1;
    }
    else  {
        $node=1;
    }
    $node=2 if ($node < 2);
    $node_idstr=$node-1;
    if (defined $2)  {
        $def_namestr=$2;
    }
    $def_namestr=~s/-/$node/g;
    $points_filestr = "points" . $node . ".dor";
    $time_off_filestr = "timeoff" . $node . ".dor";
    if ($rdstr eq "-")  {
	$points_filestr = "points0.dor";
	$time_off_filestr = "timeoff0.dor";
	$rdstr="1";
    }
}

# Snoop:
#      IF L.OCAL = 1 THEN _
#         GOTO Snoop.end
#      IF NOT SNOOP THEN
#         LOCATE 24,1,0
#         PRINT "SNOOP ON"
#         GOSUB Line25
#         SNOOP = NOT SNOOP
#       ELSE LOCATE ,,0
#         SNOOP = FALSE
#         CLS
#      END IF
# Snoop.end:
#      RETURN

sub line25  {
# Line 64005
# This would be the status line if such a beast existed.
# but it doesn't, so it doesn't really matter.
# 64005   COLOR 11,1
#        LOCATE 25,1
#        PRINT FIRST$ + " " + LAST$; _
#                          TAB(32);DOOR.NAME$; _
#                          TAB(55)"Node: " + RD$; _
#              TAB(70);ON.AT$ + " "
#        COLOR 7,0
#        RETURN
}

sub uplow  {
        
        $convstr=uc($argstr);
        $argstr=$convstr;
}

sub ansi_color  {
        if ($fc == $bc)  {
                $bc=0;
        }
        $acstr="\x1b[0;3";
#        $acstr="\x1b[3";

        $remote_ansistr=$acstr.substr($fc,0,1).    # FROM HERE ON OUT REMOTE
                            ";4".substr($bc,0,1);  # USER ROUTINE
        if ($blink == 1)  {
                $remote_ansistr.=";5";
        }
        if ($high == 1)  {
                $remote_ansistr.=";1";
        }
        $remote_ansistr.="m";
        Out($remote_ansistr);
        $blink = 0;
        $high=0;
}

sub ansi_col  {
        $c_olor[0]  = 0 ; #black
        $c_olor[1]  = 4 ; #red
        $c_olor[2]  = 2 ; #green
        $c_olor[3]  = 6 ; #yellow (brown]
        $c_olor[4]  = 1 ; #blue
        $c_olor[5]  = 5 ; #magenta
        $c_olor[6]  = 3 ; #cyan
        $c_olor[7]  = 7 ; #white
        $c_olor[8]  = 8 ; #grey
        $c_olor[9]  = 12; #light red
        $c_olor[10] = 10; #light green
        $c_olor[11] = 14; #yellow
        $c_olor[12] = 9 ; #light blue
        $c_olor[13] = 13; #light magenta
        $c_olor[14] = 11; #light cyan
        $c_olor[15] = 15; #white
        $c_olor[16] = 16; #black      (blink)
        $c_olor[17] = 20; #red        (blink)
        $c_olor[18] = 18; #green      (blink)
        $c_olor[19] = 22; #yellow     (blink)
        $c_olor[20] = 17; #blue       (blink)
        $c_olor[21] = 21; #magenta    (blink)
        $c_olor[22] = 19; #cyan       (blink)
        $c_olor[23] = 23; #white      (blink)
        $c_olor[24] = 24; #grey       (blink)
        $c_olor[25] = 28; #light red  (blink)
        $c_olor[26] = 26; #lght green (blink)
        $c_olor[27] = 30; #yellow     (blink)
        $c_olor[28] = 25; #light blue (blink)
        $c_olor[29] = 29; #lt magenta (blink)
        $c_olor[30] = 27; #lt cyan    (blink)
        $c_olor[31] = 31; #white      (blink)
}

#         SUB PARSE.NAME(RBBS.USERS.NAME$) STATIC
#         WHILE RIGHT$(RBBS.USERS.NAME$,1) = " "
#                RBBS.USERS.NAME$ = LEFT$(RBBS.USERS.NAME$,LEN(RBBS.USERS.NAME$)-1)
#         WEND
#         END SUB


sub alias  {
        $found = 0;
        &get_alias(\$firststr,\$laststr,\$found);
	if ($found == 1) {
		$found = 0;
		return;
	}
alias1:
	$noret = 1;
        &in_put("$firststr Do you wish to use an Alias? ");
	if (uc(substr($argstr,0,1)) eq 'N')  {
		$lnstr = '';
		&out_put;
		$alias_firststr = $firststr;
		$alias_laststr = $laststr;
                &put_alias(\$firststr,\$laststr,\$alias_firststr,\$alias_laststr);
		return;
	}
alias2:
	$lnstr = "Enter the FIRST name of your Alias? ";
	$noret = 1;
	&out_put;
	&in_put;
	goto alias1 if ($argstr eq '');
	&nam_adj(\$argstr);
        if ($argstr eq "Sysop" || $argstr eq 'Cabal')  {
		$lnstr = "That ALIAS is NOT allowed. Please choose another.";
		&out_put;
		goto alias2;
	}
        $alias_firststr = $argstr;
	$lnstr = '';
	&out_put;
alias3:
	$lnstr = "Enter the LAST name of your Alias? ";
	$noret = 1;
	&out_put;
	&in_put;
	goto alias3 if ($argstr eq '');
	&nam_adj(\$argstr);
	if ($argstr eq 'Sysop' || $argstr eq 'Cabal')  {
		$lnstr = "That Alias is NOT allowed. Please choose another.";
		&out_put;
		goto alias3;
	}
	$alias_laststr = $argstr;
        $full_aliasstr = "$alias_firststr $alias_laststr";
        &check_alias(\$full_aliasstr,\$found);
	if ($found == 1)  {
		$lnstr = "I'm sorry $firststr, but that Alias is already in use";
		&out_put;
		goto alias2;
	}
	$lnstr = "$firststr $laststr  a.k.a $full_aliasstr";
	&out_put;
	$lnstr = '';
	&out_put;
	$lnstr = "Is this correct (Y/[N])? ";
	$noret = 1;
	&out_put;
	&in_put;
	if (uc(substr($argstr,0,1)) eq 'Y')  {
                &put_alias(\$firststr,\$laststr,\$alias_firststr,\$alias_laststr);
		$lnstr = '';
		&out_put;
		$lnstr = "Your Alias has been recorded. Have fun!";
		&out_put;
		$lnstr = '';
		&out_put;
		$firststr = $alias_firststr;
		$laststr = $alias_laststr;
		return;
	}
	goto alias1;
}

1;
